# -*- coding: utf-8 -*-

from warriors.warrior import Warrior


class Finger_warrior (Warrior):
    def __init__(self, host, port, workdir, proto, ebrute, username, ulist, password, plist, notuse, engine, ipv6, domain, interactive, verbose):
        port = port if port != "0" else "21"
        Warrior.__init__(self, host, port, proto, workdir, ebrute, username, ulist, password, plist, notuse, interactive, verbose, engine, ipv6, domain)
        self.usernames = ulist if len(ulist) > 0 else self.wordlists_path+'/simple-users.txt'

        self.cmds = [
            {"name": "ftp_nmap", "cmd": 'nmap -sV --script "ftp* and default" -p ' + self.port + ' ' + self.host, "shell": True, "chain": False},
            {"name": "ftp_nmap_vuln", "cmd": 'nmap -sV --script "ftp* and vuln" -p ' + self.port + ' ' + self.host, "shell": True, "chain": False},
            {"name": "ftp_version", "cmd": 'timeout 10 nc -vn ' + self.host + ' ' + self.port, "shell": True, "chain": False},

        ]

        msfmodules = [{"path": "auxiliary/scanner/ftp/anonymous", "toset": {"RHOSTS": self.host, "RPORT": self.host}},
                      {"path": "auxiliary/scanner/ftp/ftp_version", "toset": {"RHOSTS": self.host, "RPORT": self.host}},]

        self.cmds.append({"name": "ftp_msf", "cmd": self.create_msf_cmd(msfmodules), "shell": True, "chain": False})
