# -*- coding: utf-8 -*-

from warriors.warrior import Warrior

class Oracle_warrior (Warrior):
    def __init__(self, host, port, workdir, proto, ebrute, username, ulist, password, plist, notuse, engine, ipv6, domain, interactive, verbose):
        port = port if port != "0" else "1521"
        Warrior.__init__(self, host, port, proto, workdir, ebrute, username, ulist, password, plist, notuse, interactive, verbose, engine, ipv6, domain)
        self.usernames = ulist if len(ulist) > 0 else self.wordlists_path+'/sids-oracle.txt'

        self.cmds = [
            {"name": "oracle_nmap", "cmd": 'nmap --script "oracle-tns-version" -T4 -sV -p '+ self.port +' '+ self.host, "shell": True, "chain": False},
            {"name": "tnscmd10g_version", "cmd": 'tnscmd10g version -p '+ self.port +' -h '+ self.host, "shell": False, "chain": False},
            {"name": "tnscmd10g_status", "cmd": 'tnscmd10g status -p '+ self.port +' -h '+ self.host, "shell": False, "chain": False},
            {"name": "oscanner", "cmd": 'oscanner -p '+ self.port +' -s '+ self.host, "shell": False, "chain": False},
            {"name": "odat_all", "cmd": 'odat.py all -p '+ self.port +' -s '+ self.host, "shell": False, "chain": False},
            {"name": "hydra_sids", "cmd": 'hydra -L '+self.usernames+' -s '+self.port+' '+self.host+' oracle-sid', "shell": False, "chain": False},
            
        ]

