# 50030,50060,50070,50075,50090 - Pentesting Hadoop

**Information taken from the book** [**Network Security Assesment 3rd Edition**](https://www.amazon.com/Network-Security-Assessment-Know-Your-ebook/dp/B01N6E0BG2)\*\*\*\*

## **Basic Information**

Apache Hadoop is an open source framework supporting the distributed storage and processing of large datasets using computer clusters. Storage is handled by the Hadoop Distributed File System \(HDFS\) and processing is performed by using MapReduce and other applications \(e.g., Apache Storm, Flink, and Spark\) via YARN.

![](../.gitbook/assets/image%20%28145%29.png)

Figure 15-1. Hadoop 2.0 architecture

You can query MapReduce and HDFS services by using the Nmap scripts listed in the following table \(including details of the default ports\). At the time of writing, Metasploit does not support Hadoop.

| **Script name** | **Port** | **Purpose** |
| :--- | :--- | :--- |
| hadoop-jobtracker-info | 50030 | Retrieve information from MapReduce job and task tracker services |
| hadoop-tasktracker-info | 50060 |  |
| hadoop-namenode-info | 50070 | Retrieve info from HDFS name node |
| hadoop-datanode-info | 50075 | Retrieve info from HDFS data node |
| hadoop-secondary-namenode-info | 50090 | Retrieve info from HDFS secondary name node |

Lightweight Python and Go HDFS clients are available online. Hadoop runs without authentication by default. You can configure HDFS, YARN, and MapReduce services to use Kerberos.

