# PHP - Useful Functions \(disabled bypass\)

## PHP check disabled functions

If you can see the output of _**phpinfo\(\)**_, look for the section about **disable\_functions.** There you will find the list of disabled functions.

![](https://0xrick.github.io/images/hackthebox/kryptos/17.png)

### Bypassing

A way to **bypass the common disabled functions** is using [https://github.com/TarlogicSecurity/Chankro](https://github.com/TarlogicSecurity/Chankro)  
that bypass them using the php functionns _**mail\(\)**_ and _**putenv\(\)**._

### Use PHP capabilities

Note that using **PHP** you can **read and write files, create directories and change permissions**.  
You can even **dump databases**.  
Maybe using **PHP** to **enumerate** the box you can find a way to escalate privileges/execute commands.

I have created a webshell that makes very easy to perform this actions: [https://github.com/carlospolop/phpwebshelllimited](https://github.com/carlospolop/phpwebshelllimited)

## PHPCommand Execution

**exec** - Returns last line of commands output  
**passthru** - Passes commands output directly to the browser  
**system** - Passes commands output directly to the browser and returns last line  
**shell\_exec** - Returns commands output  
**\`\`** \(backticks\) - Same as shell\_exec\(\)  
**popen** - Opens read or write pipe to process of a command  
**proc\_open** - Similar to popen\(\) but greater degree of control  
**pcntl\_exec** - Executes a program  
**mail** and **putenv** - Chankro tool

### PHP Code Execution

Apart from eval there are other ways to execute PHP code: include/require can be used for remote code execution in the form of Local File Include and Remote File Include vulnerabilities.  
**eval\(\)**  
assert\(\) - identical to eval\(\)  
**preg\_replace\('/.\*/e',...\)** - /e does an eval\(\) on the match  
**create\_function\(\)** - Create a function and use eval\(\)  
**include\(\)**  
**include\_once\(\)**  
**require\(\)**  
**require\_once\(\)**  
**$\_GET\['func\_name'\]\($\_GET\['argument'\]\);**  
**$func = new ReflectionFunction\($\_GET\['func\_name'\]\);  
$func-&gt;invoke\(\);**  or  
**$func-&gt;invokeArgs\(array\(\)\);  
serialize/unserialize**

### List of functions which accept callbacks

These functions accept a string parameter which could be used to call a function of the attacker's choice. Depending on the function the attacker may or may not have the ability to pass a parameter. In that case an Information Disclosure function like phpinfo\(\) could be used.  
Function =&gt; Position of callback arguments  
'ob\_start' =&gt; 0,  
'array\_diff\_uassoc' =&gt; -1,  
'array\_diff\_ukey' =&gt; -1,  
'array\_filter' =&gt; 1,  
'array\_intersect\_uassoc' =&gt; -1,  
'array\_intersect\_ukey' =&gt; -1,  
'array\_map' =&gt; 0,  
'array\_reduce' =&gt; 1,  
'array\_udiff\_assoc' =&gt; -1,  
'array\_udiff\_uassoc' =&gt; array\(-1, -2\),  
'array\_udiff' =&gt; -1,  
'array\_uintersect\_assoc' =&gt; -1,  
'array\_uintersect\_uassoc' =&gt; array\(-1, -2\),  
'array\_uintersect' =&gt; -1,  
'array\_walk\_recursive' =&gt; 1,  
'array\_walk' =&gt; 1,  
'assert\_options' =&gt; 1,  
'uasort' =&gt; 1,  
'uksort' =&gt; 1,  
'usort' =&gt; 1,  
'preg\_replace\_callback' =&gt; 1,  
'spl\_autoload\_register' =&gt; 0,  
'iterator\_apply' =&gt; 1,  
'call\_user\_func' =&gt; 0,  
'call\_user\_func\_array' =&gt; 0,  
'register\_shutdown\_function' =&gt; 0,  
'register\_tick\_function' =&gt; 0,  
'set\_error\_handler' =&gt; 0,  
'set\_exception\_handler' =&gt; 0,  
'session\_set\_save\_handler' =&gt; array\(0, 1, 2, 3, 4, 5\),  
'sqlite\_create\_aggregate' =&gt; array\(2, 3\),  
'sqlite\_create\_function' =&gt; 2,

### Information Disclosure

Most of these function calls are not sinks. But rather it maybe a vulnerability if any of the data returned is viewable to an attacker. If an attacker can see phpinfo\(\) it is definitely a vulnerability.  
**phpinfo**  
**posix\_mkfifo**  
**posix\_getlogin**  
**posix\_ttyname**  
**getenv**  
**get\_current\_user**  
**proc\_get\_status**  
**get\_cfg\_var**  
**disk\_free\_space**  
**disk\_total\_space**  
**diskfreespace**  
**getcwd**  
**getlastmo**  
**getmygid**  
**getmyinode**  
**getmypid**  
**getmyuid**

### Other

**extract** - Opens the door for register\_globals attacks \(see study in scarlet\).  
**parse\_str** - works like extract if only one argument is given.  
putenv  
**ini\_set**  
**mail** - has CRLF injection in the 3rd parameter, opens the door for spam.  
**header** - on old systems CRLF injection could be used for xss or other purposes, now it is still a problem if they do a header\("location: ..."\); and they do not die\(\);. The script keeps executing after a call to header\(\), and will still print output normally. This is nasty if you are trying to protect an administrative area.  
**proc\_nice**  
**proc\_terminate**  
**proc\_close**  
**pfsockopen**  
**fsockopen**  
**apache\_child\_terminate**  
**posix\_kill**  
**posix\_mkfifo**  
**posix\_setpgid**  
**posix\_setsid**  
**posix\_setuid**

### Filesystem Functions

According to RATS all filesystem functions in php are nasty. Some of these don't seem very useful to the attacker. Others are more useful than you might think. For instance if allow\_url\_fopen=On then a url can be used as a file path, so a call to copy\($\_GET\['s'\], $\_GET\['d'\]\); can be used to upload a PHP script anywhere on the system. Also if a site is vulnerable to a request send via GET everyone of those file system functions can be abused to channel and attack to another host through your server.

**Open filesystem handler**

**fopen**  
**tmpfile**  
**bzopen**  
**gzopen**  
**SplFileObject**-&gt;\_\_construct

**Write to filesystem \(partially in combination with reading\)**

**chgrp**  
**chmod**  
**chown**  
**copy**  
**file\_put\_contents**  
**lchgrp**  
**lchown**  
**link**  
**mkdir**  
**move\_uploaded\_file**  
**rename**  
**rmdir**  
**symlink**  
**tempnam**  
**touch**  
**unlink**  
**imagepng**  - 2nd parameter is a path.  
**imagewbmp** - 2nd parameter is a path.  
**image2wbmp** - 2nd parameter is a path.  
**imagejpeg** - 2nd parameter is a path.  
**imagexbm** - 2nd parameter is a path.  
**imagegif** - 2nd parameter is a path.  
**imagegd** - 2nd parameter is a path.  
**imagegd2** - 2nd parameter is a path.  
**iptcembed**  
**ftp\_get**  
**ftp\_nb\_get**  
**scandir**

**Read from filesystem**

**file\_exists**  
**-- file\_get\_contents**  
**file**  
**fileatime**  
**filectime**  
**filegroup**  
**fileinode**  
**filemtime**  
**fileowner**  
**fileperms**  
**filesize**  
**filetype**  
**glob**  
**is\_dir**  
**is\_executable**  
**is\_file**  
**is\_link**  
**is\_readable**  
**is\_uploaded\_file**  
**is\_writable**  
**is\_writeable**  
**linkinfo**  
**lstat**  
**parse\_ini\_file**  
**pathinfo**  
**readfile**  
**readlink**  
**realpath**  
**stat**  
**gzfile**  
**readgzfile**  
**getimagesize**  
**imagecreatefromgif**  
**imagecreatefromjpeg**  
**imagecreatefrompng**  
**imagecreatefromwbmp**  
**imagecreatefromxbm**  
**imagecreatefromxpm**  
**ftp\_put**  
**ftp\_nb\_put**  
**exif\_read\_data**  
**read\_exif\_data**  
**exif\_thumbnail**  
**exif\_imagetype**  
**hash\_file**  
**hash\_hmac\_file**  
**hash\_update\_file**  
**md5\_file**  
**sha1\_file**  
**-- highlight\_file**  
**-- show\_source**  
**php\_strip\_whitespace**  
**get\_meta\_tags**

